<?php
namespace ExtDev\Selfregistration\Domain\Repository;

/***************************************************************
 *
 * This is free and unencumbered software 
 * released into the public domain.
 *
 * (C0) 2018 ext/dev <info@extdev.io>
 *
 ***************************************************************/

class FrontendUserRepository extends \TYPO3\CMS\Extbase\Domain\Repository\FrontendUserRepository
{
    public function findByUsername(String $username)
    {
        $query = $this->createQuery();

        $constraints = array(
            $query->equals('username', $username)
        );

        $query->matching(
            $query->logicalAnd($constraints)
        );
        return $query->execute();
    }

    public function findByVerificationCode(String $verificationCode)
    {
        $query = $this->createQuery();

        $query->getQuerySettings()->setIgnoreEnableFields(true);

        $constraints = array(
            $query->equals('tx_selfregister_verification_code', $verificationCode),
            $query->equals('deleted', 0)
        );

        $query->matching(
            $query->logicalAnd($constraints)
        );

        $result = $query->execute()->toArray();
        if(count($result) > 0) {
            return $result[0];
        } else {
            return NULL;
        }
    }
}
